/*
 * Copyright 2021-2021 Alfresco Software, Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program (3.0.29).
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */
package org.alfresco.activiti.handler;

import org.alfresco.activiti.model.GlobalDateFormatRepresentation;
import org.alfresco.activiti.model.PasswordValidationConstraints;
import org.alfresco.activiti.model.SystemPropertiesRepresentation;

import io.swagger.annotations.*;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestPart;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.bind.annotation.CookieValue;
import org.springframework.cloud.openfeign.CollectionFormat;

import javax.validation.Valid;
import javax.validation.constraints.*;
import java.util.List;
import java.util.Map;

@Api(value = "SystemProperties", description = "the SystemProperties API")
public interface SystemPropertiesApi {

    @ApiOperation(value = "Get global date format", nickname = "getGlobalDateFormatUsingGET", notes = "", response = GlobalDateFormatRepresentation.class, tags={ "system-properties", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "OK", response = GlobalDateFormatRepresentation.class) })
    @RequestMapping(value = "/activiti-app/api/enterprise/system/properties/global-date-format/{tenantId}",
        produces = "application/json", 
        method = RequestMethod.GET)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<GlobalDateFormatRepresentation> getGlobalDateFormatUsingGET(@ApiParam(value = "tenantId", required=true) @PathVariable("tenantId") Long tenantId);


    @ApiOperation(value = "Get password validation constraints", nickname = "getPasswordValidationConstraintsUsingGET", notes = "", response = PasswordValidationConstraints.class, tags={ "system-properties", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "OK", response = PasswordValidationConstraints.class) })
    @RequestMapping(value = "/activiti-app/api/enterprise/system/properties/password-validation-constraints/{tenantId}",
        produces = "application/json", 
        method = RequestMethod.GET)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<PasswordValidationConstraints> getPasswordValidationConstraintsUsingGET(@ApiParam(value = "tenantId", required=true) @PathVariable("tenantId") Long tenantId);


    @ApiOperation(value = "Retrieve system properties", nickname = "getPropertiesUsingGET", notes = "Typical value is AllowInvolveByEmail", response = SystemPropertiesRepresentation.class, tags={ "system-properties", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "OK", response = SystemPropertiesRepresentation.class) })
    @RequestMapping(value = "/activiti-app/api/enterprise/system/properties",
        produces = "application/json", 
        method = RequestMethod.GET)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<SystemPropertiesRepresentation> getPropertiesUsingGET();


    @ApiOperation(value = "Get involved users who can edit forms", nickname = "involvedUsersCanEditFormsUsingGET", notes = "", response = Boolean.class, tags={ "system-properties", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "OK", response = Boolean.class) })
    @RequestMapping(value = "/activiti-app/api/enterprise/system/properties/involved-users-can-edit-forms/{tenantId}",
        produces = "application/json", 
        method = RequestMethod.GET)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<Boolean> involvedUsersCanEditFormsUsingGET(@ApiParam(value = "tenantId", required=true) @PathVariable("tenantId") Long tenantId);

}
