/*
 * Copyright 2021-2021 Alfresco Software, Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program (3.0.29).
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */
package org.alfresco.activiti.handler;

import org.alfresco.activiti.model.AssigneeIdentifierRepresentation;
import org.alfresco.activiti.model.FormIdentifierRepresentation;
import org.alfresco.activiti.model.TaskRepresentation;
import org.alfresco.activiti.model.UserIdentifierRepresentation;

import io.swagger.annotations.*;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestPart;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.bind.annotation.CookieValue;
import org.springframework.cloud.openfeign.CollectionFormat;

import javax.validation.Valid;
import javax.validation.constraints.*;
import java.util.List;
import java.util.Map;

@Api(value = "TaskActions", description = "the TaskActions API")
public interface TaskActionsApi {

    @ApiOperation(value = "Assign a task to a user", nickname = "assignTaskUsingPUT", notes = "", response = TaskRepresentation.class, tags={ "task-actions", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "OK", response = TaskRepresentation.class) })
    @RequestMapping(value = "/activiti-app/api/enterprise/tasks/{taskId}/action/assign",
        produces = "application/json", 
        consumes = "application/json",
        method = RequestMethod.PUT)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<TaskRepresentation> assignTaskUsingPUT(@ApiParam(value = "taskId", required=true) @PathVariable("taskId") String taskId, @ApiParam(value = "" ) @Valid @RequestBody AssigneeIdentifierRepresentation body);


    @ApiOperation(value = "Attach a form to a task", nickname = "attachFormUsingPUT", notes = "", tags={ "task-actions", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "OK") })
    @RequestMapping(value = "/activiti-app/api/enterprise/tasks/{taskId}/action/attach-form",
        consumes = "application/json",
        method = RequestMethod.PUT)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<Void> attachFormUsingPUT(@ApiParam(value = "taskId", required=true) @PathVariable("taskId") String taskId, @ApiParam(value = "" ) @Valid @RequestBody FormIdentifierRepresentation body);


    @ApiOperation(value = "Claim a task", nickname = "claimTaskUsingPUT", notes = "To claim a task (in case the task is assigned to a group)", tags={ "task-actions", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "OK") })
    @RequestMapping(value = "/activiti-app/api/enterprise/tasks/{taskId}/action/claim",
        method = RequestMethod.PUT)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<Void> claimTaskUsingPUT(@ApiParam(value = "taskId", required=true) @PathVariable("taskId") String taskId);


    @ApiOperation(value = "Complete a task", nickname = "completeTaskUsingPUT", notes = "Use this endpoint to complete a standalone task or task without a form", tags={ "task-actions", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "OK") })
    @RequestMapping(value = "/activiti-app/api/enterprise/tasks/{taskId}/action/complete",
        method = RequestMethod.PUT)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<Void> completeTaskUsingPUT(@ApiParam(value = "taskId", required=true) @PathVariable("taskId") String taskId);


    @ApiOperation(value = "Delegate a task", nickname = "delegateTaskUsingPUT", notes = "", tags={ "task-actions", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "OK") })
    @RequestMapping(value = "/activiti-app/api/enterprise/tasks/{taskId}/action/delegate",
        consumes = "application/json",
        method = RequestMethod.PUT)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<Void> delegateTaskUsingPUT(@ApiParam(value = "taskId", required=true) @PathVariable("taskId") String taskId, @ApiParam(value = "" ) @Valid @RequestBody UserIdentifierRepresentation body);


    @ApiOperation(value = "Involve a group with a task", nickname = "involveGroupUsingPOST", notes = "", tags={ "task-actions", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "OK") })
    @RequestMapping(value = "/activiti-app/api/enterprise/tasks/{taskId}/groups/{groupId}",
        method = RequestMethod.POST)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<Void> involveGroupUsingPOST(@ApiParam(value = "taskId", required=true) @PathVariable("taskId") String taskId, @ApiParam(value = "groupId", required=true) @PathVariable("groupId") String groupId);


    @ApiOperation(value = "Involve a user with a task", nickname = "involveUserUsingPUT", notes = "", tags={ "task-actions", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "OK") })
    @RequestMapping(value = "/activiti-app/api/enterprise/tasks/{taskId}/action/involve",
        consumes = "application/json",
        method = RequestMethod.PUT)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<Void> involveUserUsingPUT(@ApiParam(value = "taskId", required=true) @PathVariable("taskId") String taskId, @ApiParam(value = "" ) @Valid @RequestBody UserIdentifierRepresentation body);


    @ApiOperation(value = "Remove a form from a task", nickname = "removeFormUsingDELETE", notes = "", tags={ "task-actions", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "OK") })
    @RequestMapping(value = "/activiti-app/api/enterprise/tasks/{taskId}/action/remove-form",
        method = RequestMethod.DELETE)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<Void> removeFormUsingDELETE(@ApiParam(value = "taskId", required=true) @PathVariable("taskId") String taskId);


    @ApiOperation(value = "Remove an involved group from a task", nickname = "removeInvolvedUserUsingDELETE", notes = "", tags={ "task-actions", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "OK") })
    @RequestMapping(value = "/activiti-app/api/enterprise/tasks/{taskId}/groups/{groupId}",
        method = RequestMethod.DELETE)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<Void> removeInvolvedUserUsingDELETE(@ApiParam(value = "taskId", required=true) @PathVariable("taskId") String taskId, @ApiParam(value = "groupId", required=true) @PathVariable("groupId") String groupId);


    @ApiOperation(value = "Remove an involved user from a task", nickname = "removeInvolvedUserUsingPUT", notes = "", tags={ "task-actions", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "OK") })
    @RequestMapping(value = "/activiti-app/api/enterprise/tasks/{taskId}/action/remove-involved",
        consumes = "application/json",
        method = RequestMethod.PUT)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<Void> removeInvolvedUserUsingPUT(@ApiParam(value = "taskId", required=true) @PathVariable("taskId") String taskId, @ApiParam(value = "" ) @Valid @RequestBody UserIdentifierRepresentation body);


    @ApiOperation(value = "Resolve a task", nickname = "resolveTaskUsingPUT", notes = "", tags={ "task-actions", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "OK") })
    @RequestMapping(value = "/activiti-app/api/enterprise/tasks/{taskId}/action/resolve",
        method = RequestMethod.PUT)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<Void> resolveTaskUsingPUT(@ApiParam(value = "taskId", required=true) @PathVariable("taskId") String taskId);


    @ApiOperation(value = "Unclaim a task", nickname = "unclaimTaskUsingPUT", notes = "To unclaim a task (in case the task was assigned to a group)", tags={ "task-actions", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "OK") })
    @RequestMapping(value = "/activiti-app/api/enterprise/tasks/{taskId}/action/unclaim",
        method = RequestMethod.PUT)
    @CollectionFormat(feign.CollectionFormat.CSV)
    ResponseEntity<Void> unclaimTaskUsingPUT(@ApiParam(value = "taskId", required=true) @PathVariable("taskId") String taskId);

}
