/*
 * Copyright 2021-2021 Alfresco Software, Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.alfresco.activiti.model;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;
import org.alfresco.activiti.model.AppDefinitionRepresentation;
import org.springframework.validation.annotation.Validated;
import javax.validation.Valid;
import javax.validation.constraints.*;

/**
 * RuntimeAppDefinitionSaveRepresentation
 */
@Validated


public class RuntimeAppDefinitionSaveRepresentation   {
  @JsonProperty("appDefinitions")
  @Valid
  private List<AppDefinitionRepresentation> appDefinitions = null;

  public RuntimeAppDefinitionSaveRepresentation appDefinitions(List<AppDefinitionRepresentation> appDefinitions) {
    this.appDefinitions = appDefinitions;
    return this;
  }

  public RuntimeAppDefinitionSaveRepresentation addAppDefinitionsItem(AppDefinitionRepresentation appDefinitionsItem) {
    if (this.appDefinitions == null) {
      this.appDefinitions = new ArrayList<>();
    }
    this.appDefinitions.add(appDefinitionsItem);
    return this;
  }

  /**
   * Get appDefinitions
   * @return appDefinitions
   **/
  @ApiModelProperty(value = "")
      @Valid
    public List<AppDefinitionRepresentation> getAppDefinitions() {
    return appDefinitions;
  }

  public void setAppDefinitions(List<AppDefinitionRepresentation> appDefinitions) {
    this.appDefinitions = appDefinitions;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    RuntimeAppDefinitionSaveRepresentation runtimeAppDefinitionSaveRepresentation = (RuntimeAppDefinitionSaveRepresentation) o;
    return Objects.equals(this.appDefinitions, runtimeAppDefinitionSaveRepresentation.appDefinitions);
  }

  @Override
  public int hashCode() {
    return Objects.hash(appDefinitions);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class RuntimeAppDefinitionSaveRepresentation {\n");
    
    sb.append("    appDefinitions: ").append(toIndentedString(appDefinitions)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}
